#include <iostream>
#include <cmath>
#include <algorithm>
#define endl '\n'
using namespace std;

const int maxn = 100002;
int n, k, s, p[maxn];

int time(int pos, int l)
{
    int i=pos;
    while(p[i]-p[pos-1] < l) i++;
    return i;
}

int solve(int l)
{
    int i=0, tsum = 0, maxtime = 0, ttime = 0;
    while(i<n)
    {
        if(p[n-1]-tsum >= l)
        {
            int j = time(i,l);
            int h = (p[j]-p[i-1]);
            tsum += h;
            ttime = h/s;
            if(h%s!=0) ttime++;
            if(ttime > maxtime)
            {
                maxtime = ttime;
            }
            i = j+1;
        }
        else
        {
            int h = (p[n-1]-p[i-1]);
            ttime = h/s;
            if(h%s!=0) ttime++;
            if(ttime > maxtime)
            {
                maxtime = ttime;
            }
            i = n;
        }
    }
    return maxtime;
}

void read()
{
    cin >> n >> k >> s ;
    int x;
    cin >> x ;
    p[0] = x;
    for(int i=1; i<n; i++)
    {
        cin >> x ;
        p[i] = p[i-1]+x;
    }
    int l1 = p[n-1]/k;
    int l2 = l1+1;
    int ans1 = solve(l1);
    int ans2 = solve(l2);
    if(ans1 > ans2) ans1 = ans2;
    cout << ans1 << endl;
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
