#include <iostream>
#include <cmath>
#include <algorithm>
#define endl '\n'
using namespace std;

const long long maxn = 100002;
long long n, k, s, p[maxn];

long long time(long long pos, long long l)
{
    long long i=pos;
    while(p[i]-p[pos-1] < l) i++;
    return i;
}

long long solve(long long l)
{
    long long i=0, tsum = 0, maxtime = 0, ttime = 0;
    while(i<n)
    {
        if(p[n-1]-tsum >= l)
        {
            long long j = time(i,l);
            long long h = (p[j]-p[i-1]);
            tsum += h;
            ttime = h/s;
            if(h%s!=0) ttime++;
            if(ttime > maxtime)
            {
                maxtime = ttime;
            }
            i = j+1;
        }
        else
        {
            long long h = (p[n-1]-p[i-1]);
            ttime = h/s;
            if(h%s!=0) ttime++;
            if(ttime > maxtime)
            {
                maxtime = ttime;
            }
            i = n;
        }
    }
    return maxtime;
}

void read()
{
    cin >> n >> k >> s ;
    long long x;
    cin >> x ;
    p[0] = x;
    for(long long i=1; i<n; i++)
    {
        cin >> x ;
        p[i] = p[i-1]+x;
    }
    long long l1 = p[n-1]/k;
    long long l2 = l1+1;
    long long l3 = l1-1;
    long long ans1 = solve(l1);
    long long ans2 = solve(l2);
    if(ans1 > ans2) ans1 = ans2;
    cout << ans1-1 << endl;
}



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
