#include <iostream>
#include <cmath>
#include <algorithm>
#define endl '\n'
using namespace std;

const int maxn = 4096;
bool a[maxn][maxn];
int n,m;

void read()
{
    cin >> n >> m ;
    char c;
    for(int i=1; i<=n; i++)
    {
        for(int j=1; j<=m; j++)
        {
            cin >> c ;
            if(c == '0') a[i][j] = false;
            else a[i][j] = true;
        }
    }
}

bool check(int mid)
{
    bool lamp1 = true;
    int x = mid*2-1;
    int n1 = n-x+1;
    int m1 = m-x+1;
    int nn, mm;
    for(int i=1; i<=n1 && lamp1; i++)
    {
        for(int j=1; j<=m1 && lamp1; j++)
        {
            nn = i+x-1;
            mm = j+x-1;
            for(int ii=0; ii<x && lamp1; ii++)
            {
                if(!a[ii+i][ii+j]) lamp1 = false;
                if(!a[ii+i][j+x-ii-1]) lamp1 = false;
            }
            if(lamp1) lamp1 = false;
        }
    }
    return !lamp1;
}

int bin_search(int l, int r)
{
    int mid = (l+r)/2;
    while(l<=r)
    {
        if(check(mid)) l = mid+1;
        else r = mid-1;
        mid = (l+r)/2;
    }
    return r;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    int l = 1;
    int r = min(n,m);
    if(r%2!=0) r = (r/2)+1;
    else r /= 2;
    int ans = bin_search(l,r);
    ans = ans*2-1;
    cout << ans << endl;
    return 0;
}
