#include <iostream>
#include <cmath>
#include <algorithm>
#include <cstdio>
#define endl '\n'
using namespace std;

const int maxn = 4096;
bool a[maxn][maxn];
int n,m;

void read()
{
    //cin >> n >> m ;
    scanf("%d""%d",&n,&m);
    char c;
    int i, j;
    scanf("%c",&c);
    for(i=1; i<=n; ++i)
    {
        for(j=1; j<=m; ++j)
        {
            //cin >> c ;
            scanf("%c",&c);
            a[i][j] = c=='0'?false:true;
        }
        scanf("%c",&c);
    }
}

bool check(int mid)
{
    bool lamp1 = true;
    int x = mid*2-1;
    int n1 = n-x+1;
    int m1 = m-x+1;
    int i, j, ii;
    for(i=1; i<=n1 && lamp1; i++)
    {
        for(j=1; j<=m1 && lamp1; j++)
        {
            for(int ii=0; ii<x && lamp1; ii++)
            {
                lamp1 = a[ii+i][ii+j]&&a[ii+i][j+x-ii-1];
            }
            lamp1 = !lamp1;
        }
    }
    return !lamp1;
}

int bin_search(int l, int r)
{
    int mid = (l+r)/2;
    while(l<=r)
    {
        if(check(mid)) l = mid+1;
        else r = mid-1;
        mid = (l+r)/2;
    }
    return r;
}

int main()
{
    read();
    int l = 1;
    int r = n<m?n:m;
    r = r%2==0?r/2:(r/2)+1;
    int ans = bin_search(l,r);
    ans = ans*2-1;
    cout << ans << endl;
    return 0;
}
/*
10 7
1011111
1111111
1011111
1111111
0111111
1111111
1111111
1011011
1111111
1111111

10 10
0000000000
0000000000
0000000000
0000000000
0001000000
0000000000
0000000000
0000000000
0000000000
0000000000
*/

