#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int M = 3009;
char a[M][M];
int n, m;

bool check (int r, int c, int k)
{
    for (int i = 1, ri = r, ci = c; i < k; i++)
    {
        if (a[ri][ci] == '0') return 0;
        ri++, ci++;
    }
    for (int i = 1, ri = r+k, ci = c+k; i < k; i++)
    {
        if (a[ri][ci] == '0') return 0;
        ri++, ci--;
    }

    return 1;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            cin >>  a[i][j];
        }
    }

    int ans = 1;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            if (a[i][j] == '0') continue;
            int k1 = n-i;
            int k2 = m-i;
            for (int k = min(k1, k2); k >= 1; k--)
            {
                if (k%2 == 0) continue;

                //cout << i << " " << j << " " << k << "\t" << check(i, j, k) << endl;


                if (check(i, j, k))
                {
                    ans = max(ans, k);
                    break;
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}

/**
10 8
10111111
11111111
10111111
11111110
01111110
11111110
11111111
10110111
11111111
11111111

7
*/
