#include <iostream>
using namespace std;
int prefix[100009];
int howManyBugsTo[100009];
bool is_bug[100009];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int last_bug = -1;
    int numberOfBugs = 0;
    int n, t;
    cin >> n;
    string v;
    cin >> v;
    for (int i = 0; i < n; i++) {
        if (last_bug == i - 1) {
            prefix[i] = 0;
        } else {
            prefix[i] = prefix[i - 1];
        }
        if (v[i] == '(') {
            prefix[i]++;
        } else {
            prefix[i]--;
        }
        if (prefix[i] < 0) {
            last_bug = i;
            is_bug[i] = true;
            numberOfBugs++;
        }
        howManyBugsTo[i] = numberOfBugs;
    }
    cin >> t;
    for (; t > 0; t--) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((a == 0 && howManyBugsTo[b] != 0) || (howManyBugsTo[b] != howManyBugsTo[a - 1]) || v[a] == ')' || v[b] == '(' || (b - a) % 2 == 0) {
            cout << 0;
            cout << "\n";
            continue;
        }
        if (a == 0 || is_bug[a - 1]) {
            if (prefix[b] == 0) {
                cout << 1;
            } else {
                cout << 0;
            }
        } else {
            cout << 52 << endl;
            if (prefix[b] - prefix[a - 1] == 0) {
                cout << 1;
            } else {
                cout << 0;
            }
        }
        cout << "\n";
    }
    return 0;
}

