#include <iostream>
#include <string>
using namespace std;
bool pole[3000][3000];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int m, n;
    cin >> m >> n;
    for (int y = 0; y < m; y++) {
        string v;
        cin >> v;
        for (int x = 0; x < n; x++) {
            if (v[x] == '1') {
                pole[x][y] = 1;
            } else {
                pole[x][y] = 0;
            }
        }
    }
    for (int side = min(m, n); side >= 0; side--) {
        if (side == 0) {
            cout << 0;
            return 0;
        }
        if (side % 2 == 0) {
            continue;
        }
        for (int y = 0; y < m; y++) {
            if (y + side > m) {
                break;
            }
            for (int x = 0; x < n; x++) {
                if (x + side > n) {
                    break;
                }
                bool ans = true;
                for (int j = y; j - y < side; j++) {
                    if (!pole[j - (y - x)][j]) {
                        ans = false;
                        break;
                    }
                    if (!pole[x + side - 1 - j][j]) {
                        ans = false;
                        break;
                    }
                }
                if (ans) {
                    cout << side;
                    return 0;
                }
            }
        }
    }
}
