#include <iostream>
#include <cmath>
#include <algorithm>
#define endl '\n'
using namespace std;

const int maxn = 10000002;
int n, k, s, p[maxn];

int time(int pos, int l)
{
    int ii=pos;
    while(p[ii]-p[pos-1] < l) ii++;
    return ii;
}

int solve(int l)
{
    int i=1, maxtime = 0, ttime, cnt = 0;
    while(i<=n)
    {
        if(cnt < k-1)
        {
            int j = time(i,l);
            int h = (p[j]-p[i-1]);
            ttime = h/s;
            if(h%s!=0) ttime++;
            if(ttime > maxtime)
            {
                maxtime = ttime;
            }
            //cout << i << " " << tsum << " " << maxtime << endl;
            i = j+1;
            cnt++;
            //cout << cnt << endl;
        }
        else
        {
            //cout << "*" << endl;
            int h = (p[n]-p[i-1]);
            ttime = h/s;
            if(h%s!=0) ttime++;
            if(ttime > maxtime)
            {
                maxtime = ttime;
            }
            i = n+1;
            //cout << i << " " << tsum << " " << maxtime << endl;
        }
    }
    return maxtime;
}

void read()
{
    cin >> n >> k >> s ;
    int x;
    for(int i=1; i<=n; i++)
    {
        cin >> x ;
        p[i] = p[i-1]+x;
    }
    int l1 = p[n]/k;
    int l2 = l1+1;
    int l3 = l1-1;
    int ans1 = solve(l1);
    //int ans2 = solve(l2);
    //int ans3 = solve(l3);
    //int ans = min(ans1, min(ans2, ans3));
    cout << ans1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
