#include <iostream>
#include <cmath>
#include <algorithm>
#include <stack>
#define endl '\n'
using namespace std;

const int maxn = 100002;
int n, t;
string s;

bool check(int x, int y)
{
    stack<int> s1;
    bool lamp = true;
    for(int i=x; i<=y && lamp; i++)
    {
        if(s[i]==')')
        {
            if(!s1.empty() && s1.top()=='(')
            {
                s1.pop();
            }
            else lamp = false;
        }
        else
        {
            s1.push(s[i]);
        }
    }
    if(!s1.empty()) lamp = false;
    return lamp;
}

void read()
{
    cin >> n >> s >> t ;
    int x, y, i;
    for(i=0; i<t; i++)
    {
        cin >> x >> y ;
        if((y-x)%2==0) cout << "0" << endl;
        else if(check(x-1, y-1)) cout << "1" << endl;
        else cout << "0" << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
