#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int M = 3003;
char a[M][M];
int n, m;

bool check (int r, int c, int k)
{
    for (int i = 1, ri = r, ci = c; i < k; i++)
    {
        if (a[ri][ci] == '0') return 0;
        ri++, ci++;
    }
    for (int i = 1, ri = r+k, ci = c+k; i < k; i++)
    {
        if (a[ri][ci] == '0s') return 0;
        ri++, ci--;
    }

    return 1;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            char c;
            cin >> c;
            if (c == '1') a[i][j] = '1';
            else a[i][j] = '0';
        }
    }

    int ans = 1;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            for (int k = 1; i+k <= n && j+k <= m; k+=2)
            {
                //cout << i << " " << j << " " << k << "\t" << check(i, j, k) << endl;


                if (check(i, j, k))
                {
                    ans = max(ans, k);
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}

/**
10 8
10111111
11111111
10111111
11111110
01111110
11111110
11111111
10110111
11111111
11111111

7
*/
