#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int M = 3009;
char a[M][M];
int n, m;

// 2 diagonal


bool c2 (int r, int c, int i)
{
    int ri = r, ci = c+i;

    while (ri <= n && ci >= c)
    {
        if (a[ri][ci] == '0') return 0;
        ri++;
        ci--;
    }
    return 1;
}

int check (int r, int c)
{
    int ret = 0;
    int ri = r, ci = c;

    int i = 1;
    while (ri <= n && ci <= m)
    {
        if (a[ri][ci] == '0' || !c2(ri, ci, i-1)) return ret;
        ri++;
        ci++;

        if (i%2) ret = i;
        i++;
    }

    return ret;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            char c;
            cin >> c;
            if (c == '1') a[i][j] = '1';
            else a[i][j] = '0';
        }
    }

    int ans = 1;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            if (a[i][j] == '0') continue;

            ans = max(ans, check(i, j));

        }
    }

    cout << ans+1 << endl;

    return 0;
}

/**
10 8
10111111
11111111
10111111
11111110
01111110
11111110
11111111
10110111
11111111
11111111

7
*/
