#include <iostream>
#include <set>
using namespace std;
int prefix[100009];
int howManyBugsBefore[100009];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    set<int> bug_index;
    int last_bug = -1;
    int numberOfBugs = 0;
    int n, t;
    cin >> n;
    string v;
    cin >> v;
    for (int i = 0; i < n; i++) {
        if (last_bug == i - 1) {
            prefix[i] = 0;
        } else {
            prefix[i] = prefix[i - 1];
        }
        if (v[i] == '(') {
            prefix[i]++;
        } else {
            prefix[i]--;
        }
        if (prefix[i] < 0) {
            bug_index.insert(i);
            last_bug = i;
            numberOfBugs++;
        }
        howManyBugsBefore[i] = numberOfBugs;
    }
    cin >> t;
    for (; t > 0; t--) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        bool ans = true;
        if ((a == 0 && howManyBugsBefore[b] != 0) || (howManyBugsBefore[b] != howManyBugsBefore[a - 1])) {
            cout << 0;
            cout << "\n";
            continue;
        }
        if (a == 0 || bug_index.find(a - 1) != bug_index.end()) {
            if (prefix[b] == 0) {
                cout << 1;
            } else {
                cout << 0;
            }
        } else {
            if (prefix[b] - prefix[a - 1] == 0) {
                cout << 1;
            } else {
                cout << 0;
            }
        }
        cout << "\n";
    }
    return 0;
}

