#include <iostream>
using namespace std;
int prefixLeft[100009];
int prefixRight[100009];
int howManyBugsLeft[100009];
int howManyBugsRight[100009];
bool is_bugLeft[100009];
bool is_bugRight[100009];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, t;
    cin >> n;
    string v;
    cin >> v;
    int last_bug = -1;
    int numberOfBugs = 0;
    for (int i = 0; i < n; i++) {
        if (last_bug == i - 1) {
            prefixLeft[i] = 0;
        } else {
            prefixLeft[i] = prefixLeft[i - 1];
        }
        if (v[i] == '(') {
            prefixLeft[i]++;
        } else {
            prefixLeft[i]--;
        }
        if (prefixLeft[i] < 0) {
            last_bug = i;
            is_bugLeft[i] = true;
            numberOfBugs++;
        }
        howManyBugsLeft[i] = numberOfBugs;
    }
    last_bug = n;
    numberOfBugs = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (last_bug == i + 1) {
            prefixRight[i] = 0;
        } else {
            prefixRight[i] = prefixRight[i + 1];
        }
        if (v[i] == ')') {
            prefixRight[i]++;
        } else {
            prefixRight[i]--;
        }
        if (prefixRight[i] < 0) {
            last_bug = i;
            is_bugRight[i] = true;
            numberOfBugs++;
        }
        howManyBugsRight[i] = numberOfBugs;
    }
    cin >> t;
    for (; t > 0; t--) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if ((a == 0 && howManyBugsLeft[b] != 0) || (howManyBugsLeft[b] != howManyBugsLeft[a - 1]) || (b == n - 1 && howManyBugsRight[a] != 0) || (howManyBugsRight[a] != howManyBugsRight[b + 1])
            || v[a] == ')' || v[b] == '(' || (b - a) % 2 == 0) {
            cout << 0;
            cout << "\n";
            continue;
        }
        if (a == 0 || is_bugLeft[a - 1]) {
            if (prefixLeft[b] == 0) {
                cout << 1;
            } else {
                cout << 0;
            }
            cout << "\n";
            continue;
        }
        if (b == n - 1 || is_bugRight[b + 1]) {
            if (prefixRight[a] == 0) {
                cout << 1;
            } else {
                cout << 0;
            }
            cout << "\n";
            continue;
        }
        if (prefixLeft[b] - prefixLeft[a - 1] == 0 && prefixRight[a] - prefixRight[b + 1] == 0) {
            cout << 1;
        } else {
            cout << 0;
        }
        cout << "\n";
    }
    return 0;
}

